﻿Type=Class
Version=6.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@

Private Sub Class_Globals
	
	Private root As String
	Private const CM As String = ", "

	Public const OUTPUT As Byte = 0
	Public const INPUT As Byte  = 1
	Public const INPUT_PULLUP As Byte  = 2
	
	Public const LOW As Boolean = False
	Public const HIGH As Boolean = True	
	
	'Pins valid for NodeMCU and Wemos D1 Mini (need to be changed for Wemos R1)
	Public const SDA As Byte = 4
	Public const SCL As Byte = 5

	Public const LED_BUILTIN As Byte = 16  '2 for Wemos (GPIO16 on NodeMCU is a second board led, not on ESP-12E)
	Public const BUILTIN_LED As Byte = 16  '2 for Wemos
	
	Public const D0 As Byte = 16
	Public const D1 As Byte = 5
	Public const D2 As Byte = 4
	Public const D3 As Byte = 0	
	Public const D4 As Byte = 2    '(GPIO2 on NodeMCU is ESP-12E led)
	Public const D5 As Byte = 14
	Public const D6 As Byte = 12
	Public const D7 As Byte = 13	
	Public const D8 As Byte = 15
	Public const D9 As Byte = 3
	Public const D10 As Byte = 1
	Public const D11 As Byte = 9	
    Public const D12 As Byte = 10
	Public const A0 As Byte = 17	
		
    Private UDP As UDPSocket
	
	Private tPort As Int
	Private tBufferSize As Int
			
	Private GlobalPinState As Boolean = False
		
	Public Serial As MySerial
End Sub

'Initializes the ESP8266 object.
Public Sub Initialize(Port As Int, BufferSize As Int)
	tPort = Port
	tBufferSize = BufferSize
  UDP.Initialize("UDP", tPort, tBufferSize)
	Serial.Initialize
End Sub

Public Sub pinMode(Pin As Byte, Mode As Byte) As ESP8266
	root = "pinMode" & CM & Pin & CM & Mode
	sendCmd(root)	
	Return Me
End Sub

Public Sub digitalWrite(Pin As Byte, State As Boolean) As ESP8266
	root = "pinMode" & CM & Pin & CM & State
	sendCmd(root)	
	GlobalPinState = State   'just for test
	Return Me	
End Sub

Public Sub digitalRead(Pin As Byte) As Boolean
	Return handlePins(Pin)	
End Sub

' Read pin status 
Private Sub handlePins(Pin As Byte) As Boolean
'	GlobalPinState = Not(GlobalPinState) 'for now we simulate inversion of pin state, next we read UDP
                                       'messages sent from ESP8266 if any pin change it's state
	Return GlobalPinState   'just for test
End Sub

Sub UDP_PacketArrived (Packet As UDPPacket)
	' Read messages sent from ESP8266 if any pin change it's state
End Sub

' SEND ALL COMMANDS THRU UDP SOCKET
Private Sub sendCmd(s As String)
	Log("SEND1:  " & s)
End Sub
